SystemOrganization addCategory: #PEGWiki!

!ALResponse class methodsFor: '*pegwiki' stamp: 'chc 1/27/2015 15:08'!
unauthorized
	^ self status: 401 reason: 'Unauthorized' details: 'You have not logged in'! !

ALTextareaTag subclass: #PWAppTextareaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki'!

!PWAppTextareaTag methodsFor: 'accessing' stamp: 'chc 1/7/2016 18:39'!
callback: aValuable
	self name: (canvas currentForm registerCallback: aValuable) asString
! !

!PWAppTextareaTag methodsFor: 'accessing' stamp: 'chc 1/7/2016 18:39'!
send: aSelector to: anObject
	self value: (anObject perform: aSelector).
	self callback: [:v | anObject perform: aSelector asMutator with: v]! !

Object subclass: #PWAjaxComponent
	instanceVariableNames: 'html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki'!

!PWAjaxComponent class methodsFor: 'as yet unclassified' stamp: 'chc 1/2/2016 09:16'!
html: aString
	^self basicNew
		initializeWithWikiString: aString! !

!PWAjaxComponent methodsFor: 'accessing' stamp: 'chc 1/2/2016 09:17'!
html 
	^html! !

!PWAjaxComponent methodsFor: 'accessing' stamp: 'chc 1/4/2016 10:32'!
html: anObject
	html := anObject! !

!PWAjaxComponent methodsFor: 'as yet unclassified' stamp: 'chc 1/2/2016 09:16'!
initializeWithWikiString: aString
	html := aString
	! !

!PWAjaxComponent methodsFor: 'as yet unclassified' stamp: 'chc 1/2/2016 09:17'!
renderOn: json
	json object:
		[json name: 'count' value: html]! !

Object subclass: #PWFormatRequest
	instanceVariableNames: 'wikiString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki'!

!PWFormatRequest class methodsFor: 'as yet unclassified' stamp: 'chc 8/18/2015 13:41'!
username: username password: password
	^ (self withUsername: username password: password) signal! !

!PWFormatRequest class methodsFor: 'as yet unclassified' stamp: 'chc 8/18/2015 13:41'!
withUsername: username password: password
	^ self basicNew
		initializeWithUsername: username password: password! !

!PWFormatRequest methodsFor: 'initialization' stamp: 'chc 8/18/2015 13:42'!
initializeWithUsername: aUsername password: aPassword
	self initialize.
	! !

!PWFormatRequest methodsFor: 'interpreting' stamp: 'chc 8/18/2015 13:53'!
name: aString value: anObject
	aString = 'wikiString' ifTrue: [wikiString := anObject].
	! !

!PWFormatRequest methodsFor: 'interpreting' stamp: 'chc 8/18/2015 13:41'!
object: aBlock
	aBlock value
	! !

!PWFormatRequest methodsFor: 'accessing' stamp: 'chc 8/18/2015 13:42'!
wikiString

	^ wikiString! !

!PWFormatRequest methodsFor: 'accessing' stamp: 'chc 8/18/2015 13:42'!
wikiString: anObject

	wikiString := anObject! !

!ALAppHtml5Canvas methodsFor: '*pegwiki' stamp: 'chc 1/7/2016 18:42'!
textarea
	^ self open: (PWAppTextareaTag on: self)
! !

!ALJsonResource methodsFor: '*pegwiki' stamp: 'chc 1/4/2016 10:30'!
handlePost: aRequest locator: aLocator
	| request wikiString wikiGrammar parser html |
	request := PWFormatRequest new.
	aRequest readEntityWith: 
		[:in | ALJsonParser  parse: in for: request].
	"put new wiki string in the class var"
	wikiString := request wikiString.
	ALAjaxCounterExample currentString: wikiString.
	"make string to put in component"
	wikiGrammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: wikiGrammar actor: PEGParserParser new.
	html := parser parse: 'Page' stream: wikiString actor: PWActor new.
	self component html: html.
	"return response"
	"do I need a redirect so that the GET is activated?"
 	^ ALResponse 
		type: ALContentType json 
		callback: [ :out | self renderOnStream: out locator: aLocator ]

! !

!ALAsyncExample methodsFor: '*pegwiki' stamp: 'chc 1/6/2016 09:33'!
renderContentOn: html
	html span
		class: 'counter';
		id: 'count';
		with: '0'.
(ALAsyncExample render = 'on') ifTrue: [
	html form id: 'myform'; beMethodPost; with:
		[html textarea name: 'wikiString'; with: [ html text: self class currentString].
		 html br. 
		 html input beTypeSubmit ]]. 
	self renderScriptsOn: html! !

!ALAsyncExample methodsFor: '*pegwiki' stamp: 'chc 12/31/2015 12:42'!
renderScriptsOn: html
	html script src: 'https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js'.
	html script
		type: 'application/javascript';
		with: [html raw: self libraryScript].
	html script 
		type: 'application/javascript';
		with: [self renderFormScriptOn: html].
	html script
		type: 'application/javascript';
		with: [self renderInitScriptOn: html]! !

ALAsyncExample subclass: #PWConfigPage
	instanceVariableNames: 'integer something'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki'!

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 1/7/2016 18:45'!
initialize
	integer := 'off'.
	something := 'Coco Beware'! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 1/8/2016 10:26'!
renderContentOn: html
	html form beMethodGet; with:
		[ html p: 'Show homepage edit form: '.
			html input 
			beTypeRadio;
			value: 'on';
			callback: [:str | ALAsyncExample render: str ];
			with: [html text: 'On'].
		html br. 
		html input beTypeRadio;
			value: 'off';
			callback: [:str | ALAsyncExample render: str ];
			with: [html text: 'Off'].
		html br.
		html input beTypeSubmit; value: 'Save'.
		html br.
		html text: integer ].
	html form beMethodPost; with:
		[ html p: 'Enter an Installer script to pull fresh code from an online repository and load it into this deployed image:'.
		html textarea name: '2'; rows: '10';
		cols: '50';
		callback: [:str| something := str ].. 
		 html br. 
		html text: something.
		 html input beTypeSubmit; value: 'Load' ]! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'cwp 9/13/2012 13:23'!
renderStyleOn: html
	html style: 'input {margin-right: 20px}'! !

!ALAjaxCounterExample class methodsFor: '*pegwiki' stamp: 'chc 12/30/2015 20:54'!
currentString
	^currentString! !

!ALAjaxCounterExample class methodsFor: '*pegwiki' stamp: 'chc 12/30/2015 20:53'!
currentString: anObject
	currentString := anObject! !

!ALAjaxCounterExample methodsFor: '*pegwiki' stamp: 'chc 1/4/2016 10:49'!
renderFormScriptOn: html
	html raw: 
		'function ConvertFormToJson(form) {
			var array = (form).serializeArray();
			var json = {};
			jQuery.each( array, function () {
			json[this.name] = this.value || '' '';
		});
		return json;
		}

		$(myform).submit(function(event){
		event.preventDefault();

		var json = ConvertFormToJson($(myform));
		console.log(json);

		jsonstring = JSON.stringify(json);
		console.log(jsonstring);

		$.ajax({
		type: "POST",
		url: "'.

	html text: (html context registerResource: self resource) printString.

	html raw: 
		'",
		data: jsonstring,
		success: function (data) {
					var self = this;
					self.state = data;
					$(''#count'').html(self.state.count);
									}
		}) 
							});'! !

!ALAjaxCounterExample methodsFor: '*pegwiki' stamp: 'chc 1/4/2016 10:10'!
resource
	| wikiString wikiGrammar parser html |
	wikiString := self class currentString.
	wikiGrammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: wikiGrammar actor: PEGParserParser new.
	html := parser parse: 'Page' stream: wikiString actor: PWActor new.
	^ ALJsonResource component: (PWAjaxComponent html: html)! !

ALComponentResource subclass: #PWBasicAuthResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki'!

!PWBasicAuthResource commentStamp: 'chc 6/22/2015 14:50' prior: 0!
Used by ORAuthApplication. Drops down browser window for username and password.!

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 6/23/2015 16:39'!
authorized: result locator: aLocator
	| root cookie url |
	root := component rematerialize.
	url := aLocator urlForResource: root asResource.
	cookie := ALCookie name: 'auth' value: result token.
	cookie path: '/'.
	^ (ALResponse seeOther: url)
			setCookie: cookie; 
			yourself! !

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/3/2015 16:08'!
denied
	^ ALResponse status: 401 reason: 'Authentication failed'! !

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/10/2015 15:46'!
handleGet: aRequest locator: aLocator
	| request result authstring |
	(aRequest authorization isNil)
		ifTrue: [^self respondWithChallenge]
		ifFalse: [
	authstring := (aRequest authorization copyAfter: Character space) base64Decoded.
	request := ALAuthenticationRequest withUsername:  (authstring copyUpTo: $:)   password: (authstring copyAfter: $:).
	result := request signal].
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]
			! !

!PWBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/3/2015 16:15'!
respondWithChallenge
	^ALResponse unauthorized
		wwwAuthenticate: 'Basic Realm = "My Server"';
			yourself! !

TestCase subclass: #PWActorTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki'!

!PWActorTest commentStamp: '<historical>' prior: 0!
A terminal here is an OrderedCollection that does not contain another OrderedCollection. A terminal's contents is chars or strings. In the #grammarWiki that could be: 

Bold <- "*" Flow{"*"}

Angle brackets (i.e. {}) show that something is optional. To create a bold word you need an asterisk befor a or line. It will not contain any further OrderedCollections.  !

!PWActorTest methodsFor: 'private' stamp: 'chc 1/3/2016 01:41'!
setUp
	| grammar |
	grammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: grammar actor: PEGParserParser new.
	! !

!PWActorTest methodsFor: 'lexical' stamp: 'chc 1/3/2016 01:44'!
testBold
	| result |
	result := parser parse: 'Bold' stream: '*Taco Bell*' actor: ORWikiActor new.
	self assert: ( '<b>Taco Bell</b>' = result )! !

!PWActorTest methodsFor: 'structural' stamp: 'chc 1/3/2016 01:45'!
testBullet1
	| result |
	result := parser parse: 'Bullet1' stream: ' *First Item' actor: ORWikiActor new.
	self assert: ( '<li>First Item</li>' = result )! !

!PWActorTest methodsFor: 'lexical' stamp: 'chc 1/3/2016 01:45'!
testCode
	| result |
	result := parser parse: 'Code' stream: '{{{
code
}}}' actor: ORWikiActor new.
	self assert: ( '<pre>
code
</pre>' = result )! !

!PWActorTest methodsFor: 'structural' stamp: 'chc 1/3/2016 01:45'!
testHeading1
	| result |
	result := parser parse: 'Heading1' stream: '  = BigDay =
				' actor: ORWikiActor new.
	self assert: ( '<h1>BigDay</h1>' = result )! !

!PWActorTest methodsFor: 'structural' stamp: 'chc 1/3/2016 01:45'!
testHeading2
	| result |
	result := parser parse: 'Heading2' stream: '  == BigDay ==
				' actor: ORWikiActor new.
	self assert: ( '<h2>BigDay</h2>' = result )! !

!PWActorTest methodsFor: 'structural' stamp: 'chc 1/3/2016 01:45'!
testHeading3
	| result |
	result := parser parse: 'Heading3' stream: '  === BigDay ===
				' actor: ORWikiActor new.
	self assert: ( '<h3>BigDay</h3>' = result )! !

!PWActorTest methodsFor: 'lexical' stamp: 'chc 1/3/2016 01:47'!
testItalic
	| result |
	result := parser parse: 'Italic' stream: '_Taco Bell_' actor: ORWikiActor new.
	self assert: ( '<i>Taco Bell</i>' = result )! !

!PWActorTest methodsFor: 'lexical' stamp: 'chc 1/3/2016 01:45'!
testLink
	| result |
	result := parser parse: 'LinkShort' stream: '[abc]' actor: ORWikiActor new.
	self assert: ( '<a href="http://www.abc.com">abc</a>' = result )! !

!PWActorTest methodsFor: 'structural' stamp: 'chc 1/3/2016 01:46'!
testPage
	| result |
	result := parser parse: 'Page' stream: 'Taco Bell' actor: ORWikiActor new.
	self assert: ( '<div><p>Taco Bell</p></div>' = result )! !

!PWActorTest methodsFor: 'structural' stamp: 'chc 1/3/2016 01:46'!
testParagraph
	| result |
	result := parser parse: 'Page' stream: 'Taco Bell' actor: ORWikiActor new.
	self assert: ( '<div><p>Taco Bell</p></div>' = result )! !

PEGActor subclass: #PWActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PEGWiki'!

!PWActor methodsFor: 'argument' stamp: 'chc 1/2/2016 18:22'!
Bold: flow
	<action: 'Bold' arguments: #(2)>
	^'<b>' , (self collectString: flow) , '</b>'! !

!PWActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading1: flow
	<action: 'Heading1' arguments: #(3) >
	^'<h1>' , (self collectString: flow) , '</h1>'! !

!PWActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading2: flow
	<action: 'Heading2' arguments: #(3) >
	^'<h2>' , (self collectString: flow) , '</h2>'! !

!PWActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Heading3: flow
	<action: 'Heading3' arguments: #(3) >
	^'<h3>' , (self collectString: flow) , '</h3>'! !

!PWActor methodsFor: 'argument' stamp: 'chc 1/2/2016 18:21'!
Italic: flow
	<action: 'Italic' arguments: #(2)>
	^'<i>' , (self collectString: flow) , '</i>'! !

!PWActor methodsFor: 'argument' stamp: 'chc 11/25/2015 19:27'!
Link: flow
	<action: 'LinkShort' arguments: #( 2 )>
	| linkContent |
	linkContent := self collectString: flow.
	^'<a href="http://www.' , linkContent , '.com">' , linkContent , '</a>'! !

!PWActor methodsFor: 'no-argument' stamp: 'chc 1/2/2016 13:19'!
Page: flow
	<action: 'Page'>
	^'<div>' , (self collectString: flow) , '</div>'! !

!PWActor methodsFor: 'no-argument' stamp: 'chc 11/25/2015 19:28'!
Paragraph: flow
	<action: 'Paragraph'>
	^'<p>' , (self collectString: flow) , '</p>'! !

!PWActor methodsFor: 'private' stamp: 'chc 11/25/2015 19:27'!
collectString: flow
	| string |
	string := String new writing.
	flow do: [:ea| string write: ea].
	^string conclusion! !

!ALExampleApplication methodsFor: '*pegwiki' stamp: 'chc 1/6/2016 09:53'!
initializeLocator
	locator 
		at: ALPath root 
		put: ALExamplePage new asResource.
	locator 
		at: ALPath root / 'config'
		put: (PWBasicAuthResource component: (PWConfigPage new)).! !
